﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors.Primitives;
using Infragistics.Windows;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics;
using System.Reflection;
using Infragistics.Controls.Editors;

namespace MulitComboTextChanged
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = new ViewModel(); 
        }

        void HeaderClicked(object sender, MouseButtonEventArgs e)
        {
            ComboHeaderCellControl cellControl = sender as ComboHeaderCellControl;
            string columnName = cellControl.Cell.Column.Key;

            SortContext sort = xamMultiColumnComboEditor.ComboDataManager.Sort.Where(s => s.SortPropertyName.Equals(columnName)).FirstOrDefault();
            
            xamMultiColumnComboEditor.ComboDataManager.Sort.Clear();

            bool isAscending = true;
            if (sort != null)
                isAscending = !sort.SortAscending;

            xamMultiColumnComboEditor.ComboDataManager.Sort.Add(SortContext.CreateGenericSort(
                   xamMultiColumnComboEditor.ComboDataManager.CachedTypedInfo,
                   columnName,
                   isAscending,
                   false,
                   null));

            xamMultiColumnComboEditor.ComboDataManager.UpdateData();
        }

       
    }

    public class XamMultiColumnComboEditorEx : XamMultiColumnComboEditor
    {
        public DataManagerBase ComboDataManager
        {
            get
            {
                return base.DataManager;
            }
        }

    }

    #region VM

    public class ViewModel : INotifyPropertyChanged, IDataErrorInfo, IDisposable
    {
        private string _itemDisplayMemberPath;
        public string ItemDisplayMemberPath
        {
            get { return this._itemDisplayMemberPath; }
            set
            {
                if (this._itemDisplayMemberPath != value)
                {
                    this._itemDisplayMemberPath = value;
                    NotifyPropertyChanged("ItemDisplayMemberPath");
                }
            }
        }

        public string NullText { get; set; }

        private List<Customer> _list;
        public List<Customer> CustList
        {
            get { return _list; }
            set { _list = value; NotifyPropertyChanged("CustList"); }
        }

        public string StrText { get; set; }

        private Customer _Itemcust;
        public Customer ItemCust
        {
            get { return _Itemcust; }
            set { _Itemcust = value; NotifyPropertyChanged("ItemCust"); }
        }


        public ViewModel()
        {
            CustList = new CustomerList();

        }

        #region INotifyPropertyChanged Member

        public event PropertyChangedEventHandler PropertyChanged;

        void NotifyPropertyChanged(String propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion

        #region IDataErrorInfo

        public string Error
        {
            get { return ""; }
        }

        public string this[string columnName]
        {
            get
            {
                string result = null;
                switch (columnName)
                {
                    case "ItemCust":
                        result = Validate();
                        break;
                    case "StrText":
                        result = ValidateText();
                        break;
                    default:
                        break;
                }
                return result;
            }
        }

        private string ValidateText()
        {
            if (string.IsNullOrEmpty(StrText))
            {
                return "Please enter value";
            }
            return string.Empty;
        }


        private string Validate()
        {
            if (ItemCust == null)
            {
                return "error finding item";
            }
            return string.Empty;
        }



        #endregion



        #region Dispose

        public void Dispose()
        {
        }
        #endregion
    }


    public class Customer
    {

        public string Name { get; set; }

        public string Company { get; set; }

        public string Country { get; set; }

        public Complex Complex { get; set; }



        public Customer(string name, string company, string country, Complex comp)
        {

            this.Name = name;

            this.Company = company;

            this.Country = country;

            this.Complex = comp;

        }

    }

    public class Complex
    {
        public int Some { get; set; }
    }

    public class CustomerList : List<Customer>
    {

        public CustomerList()
        {

            this.Add(new Customer("John Smith".ToUpper(), "Foobar Solutions".ToUpper(), "USA", new Complex { Some = 1 }));

            this.Add(new Customer("Jane Foster".ToUpper(), "United Affiliates, Inc".ToUpper(), "USA", new Complex { Some = 3 }));

            this.Add(new Customer("Mike Patterson".ToUpper(), "Acme, Inc".ToUpper(), "Canada".ToUpper(), new Complex { Some = 2 }));

        }

    }

    #endregion
}
